//===========================================================================
//ļƣcommon.h
//ܸҪҪԴļ
//ȨУݴѧ˼Ƕʽ(sumcu.suda.edu.cn)
//¼¼2012-10-12 V1.0
//         2013-02-02 V2.0(WYH)
//===========================================================================

#include "common.h"    //Ҫͷļ

static  uint_32  int_disable_level; // ̬ǰжǶײ

//=========================================================================
//ƣinit_critical
//˵
//أ
//ܸҪʼٽʿ
//=========================================================================
void  init_critical(void) 
{
    ENABLE_INTERRUPTS;
    int_disable_level = 0;
}

//=========================================================================
//ƣenter_critical
//˵
//أ
//ܸҪٽ
//=========================================================================
void  enter_critical(void)
{
    if (0 == int_disable_level)
    {
        DISABLE_INTERRUPTS;
    }
    int_disable_level++;
}

//=========================================================================
//ƣexit_critical
//˵
//أ
//ܸҪ뿪ٽ
//=========================================================================
void  exit_critical(void) 
{
    if (int_disable_level)
    {
        int_disable_level--;
        if (0 == int_disable_level)
        {
            ENABLE_INTERRUPTS;
        }
    }
}

//============================================================================
//ƣenable_irq
//أ
//˵irqirq, ģжϺŶMKL25Z.h
//ܸҪʹirqж 
//============================================================================
void enable_irq (IRQn_Type irq)
{
    //ȷirqΪЧirq
    //if (irq > 32)	irq=32;
    
    NVIC_EnableIRQ(irq);

}

//============================================================================
//ƣdisable_irq
//أ      
//˵irqirq, ģжϺŶMKL25Z.h
//ܸҪֹirqж 
//============================================================================
void disable_irq (IRQn_Type irq)
{

    //ȷirqΪЧirq
    //if (irq > 32)	irq=32;
    
    NVIC_DisableIRQ(irq);
}
 
//============================================================================
//ƣset_irq_priority
//أ      
//˵irqirq,ģжϺŶMKL25Z.h
//         prioȼ
//ܸҪirqжϺȼ 
//============================================================================
void set_irq_priority (IRQn_Type irq, uint_16 prio)
{   
    uint_8 err = 0;
   
//    if (irq > 32)
//    {
//        err = 1;
//    }
    if (prio > 3)
    {     
        err = 1;
    }
    if (err != 1)
    {  
    	NVIC_SetPriority(irq, prio);
    }
}


//===========================================================================
//ƣSecAdd1
//أ
//˵*p:Ϊָһʱp[3]
//ܸҪ뵥Ԫ+1ʱֵԪ00:00:00-23:59:59)
//===========================================================================
void SecAdd1(uint_8 *p)
{
     *(p+2)+=1;         //+1
     if(*(p+2)>=60)     //
     {
        *(p+2)=0;       //
        *(p+1)+=1;      //+1
        if(*(p+1)>=60)  //
        {
           *(p+1)=0;    //
           *p+=1;       //ʱ+1
           if(*p>=24)   //ʱ
           {
             *p=0;      //ʱ
           }
         }
      }
}
