//===========================================================================
//ļƣcommon.h
//ܸҪҪͷļ
//ȨУݴѧ˼Ƕʽ(sumcu.suda.edu.cn)
//¼¼2012-10-12   V1.0
//         2013-02-02 V2.0(WYH)
//===========================================================================
#ifndef _COMMON_H    //ֹظ壨_COMMON_H  ͷ)
#define _COMMON_H

//1оƬĴӳļںļ
#include "S32K144.h"      // оƬͷļ
#include "core_cm4.h"
#include "core_cmFunc.h"
#include "core_cmInstr.h"
#include "system_S32K144.h"
//#include "S32K144_features.h"

//2忪ж
#define ENABLE_INTERRUPTS   __enable_irq()  //ж
#define DISABLE_INTERRUPTS  __disable_irq()  //ж


//3λ꺯λλüĴһλ״̬
#define BSET(bit,Register)  ((Register)|= (1<<(bit)))    //üĴһλ
#define BCLR(bit,Register)  ((Register) &= ~(1<<(bit)))  //Ĵһλ
#define BGET(bit,Register)  (((Register) >> (bit)) & 1)  //üĴһλ״̬

//4ضͣͱ궨壩
typedef unsigned char        uint_8;   // ޷8λֽ
typedef unsigned short int   uint_16;  // ޷16λ
typedef unsigned long int    uint_32;  // ޷32λ
typedef unsigned long long   uint_64;
typedef char                 int_8;    // з8λ
typedef short int            int_16;   // з16λ
typedef int                  int_32;   // з32λ
typedef long long            int_64;
//Ż
typedef volatile uint_8      vuint_8;  // Ż޷8λֽ
typedef volatile uint_16     vuint_16; // Ż޷16λ
typedef volatile uint_32     vuint_32; // Ż޷32λ
typedef volatile int_8       vint_8;   // Żз8λ
typedef volatile int_16      vint_16;  // Żз16λ
typedef volatile int_32      vint_32;  // Żз32λ

//ι
#define WDI_FEED() {SIM_SRVCOP = 0x55;	SIM_SRVCOP = 0xAA;}

//5. ϵͳʹõʱƵ
#define  SYSTEM_CLK_KHZ   DEFAULT_SYSTEM_CLOCK/1000// оƬϵͳʱƵ(KHz)
#define  BUS_CLK_KHZ      SYSTEM_CLK_KHZ/2         // оƬʱƵ(KHz)

// 6ٽʺ

//=========================================================================
//ƣinit_critical
//˵
//أ
//ܸҪʼٽʿ
//=========================================================================
void  init_critical(void);

//=========================================================================
//ƣenter_critical
//˵
//أ
//ܸҪٽ
//=========================================================================
void  enter_critical(void);

//=========================================================================
//ƣexit_critical
//˵
//أ
//ܸҪ뿪ٽ
//=========================================================================
void  exit_critical(void);


//============================================================================
//ƣenable_irq
//أ
//˵irqirq, ģжϺŶMKL25Z.h
//ܸҪʹirqж 
//============================================================================
void enable_irq (IRQn_Type irq);

//============================================================================
//ƣdisable_irq
//أ      
//˵irqirq, ģжϺŶMKL25Z.h
//ܸҪֹirqж 
//============================================================================
void disable_irq (IRQn_Type irq);

//============================================================================
//ƣset_irq_priority
//أ      
//˵irqirq,ģжϺŶMKL25Z.h
//          prioȼ
//ܸҪirqжϺȼ 
//============================================================================
void set_irq_priority (IRQn_Type irq, uint_16 prio);

#endif //ֹظ壨_COMMON_H  β)
